/***************************************************************************
 *            quickSort.c
 *
 *  Tue Oct 16 19:50:06 2007
 *  Copyright  2007  pchero
 *  pchero21@gmail.com
 ****************************************************************************/

/*
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */
 
#include <stdio.h>
#include <stdlib.h>

void quickSort(int low, int high);
void partition(int low, int high, int *pivotpoint);
void swap(int *a, int *b);

int *S;

int main(int argc, int **argv)
{
	
	int i, j;
	int arr_size;

	printf("insert number of array : ");
	scanf("%d", &arr_size);

	S = (int*)malloc(sizeof(int) * arr_size);
	
	// 난수 발생.
	j = arr_size;
	for(i = 0; i < arr_size; i++)
		S[i] = i;
	for(i = 0; i < (arr_size -1); i++)
		swap(&S[rand() % j], &S[--j]);	

	quickSort(0, (arr_size - 1));
	
	for(i = 0; i < arr_size; i++)
		printf("%d, ", S[i]);
	printf("\n");
	
	free(S);
	return 0;
}
 
void quickSort(int low, int high)
{
	int pivotpoint;
 
	if(high > low) {
		partition(low, high, &pivotpoint);
		quickSort(low, pivotpoint - 1);
		quickSort(pivotpoint + 1, high);
	}
}

void partition(int low, int high, int *pivotpoint)
{
	int i, j;
	int pivotitem;

	pivotitem = S[low];
	j = low;
	for(i = low + 1; i <= high; i++) {
		if(S[i] < pivotitem) {
			j++;
			swap(&S[i], &S[j]);
		}
	}
	*pivotpoint = j;
	swap(&S[low], &S[*pivotpoint]);
}
 
void swap(int *a, int *b)
{
	int temp;
	temp = *a;
	*a = *b;
	*b = temp;
}
